VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "vbzPrinter Demo"
   ClientHeight    =   2295
   ClientLeft      =   6765
   ClientTop       =   4950
   ClientWidth     =   5010
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   5010
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown-Liste
      TabIndex        =   7
      ToolTipText     =   "Drucker-Auswahl"
      Top             =   120
      Width           =   4755
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Datei drucken..."
      Height          =   375
      Left            =   3180
      TabIndex        =   2
      Top             =   540
      Width           =   1695
   End
   Begin MSComDlg.CommonDialog cmdlg 
      Left            =   2040
      Top             =   1800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      PrinterDefault  =   0   'False
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "&Beenden"
      Height          =   375
      Left            =   3540
      TabIndex        =   0
      Top             =   1800
      Width           =   1335
   End
   Begin VB.Label Label1 
      Height          =   255
      Index           =   3
      Left            =   1920
      TabIndex        =   6
      Top             =   1440
      Width           =   2895
   End
   Begin VB.Label Label1 
      Height          =   255
      Index           =   2
      Left            =   1920
      TabIndex        =   5
      Top             =   1080
      Width           =   2895
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Rechts
      Caption         =   "Anwendungs-Drucker:"
      Height          =   255
      Index           =   1
      Left            =   180
      TabIndex        =   4
      Top             =   1440
      Width           =   1635
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Rechts
      Caption         =   "Standard-Drucker:"
      Height          =   255
      Index           =   0
      Left            =   180
      TabIndex        =   3
      Top             =   1080
      Width           =   1635
   End
   Begin VB.Label vbzentrum 
      Caption         =   "www.vb-zentrum.de"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   225
      Left            =   120
      MouseIcon       =   "frmMain.frx":0CCA
      MousePointer    =   99  'Benutzerdefiniert
      TabIndex        =   1
      ToolTipText     =   "zur Homepage..."
      Top             =   1980
      Width           =   1770
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' vbzTipp   : Verschiedenes / vbzPrinter
' Nummer    : 0003
' Stand     : 19.01.2008
' Quelle    : http://www.vb-zentrum.de
' Autor     : ralf schlegel

Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
        (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
        ByVal lpParameters As String, ByVal lpDirectory As String, _
        ByVal nShowCmd As Long) As Long

Const noPrinter As String = "kein Drucker definiert!"

Private Sub cmdEnd_Click()
  Unload Me
End Sub

Private Sub cmdPrint_Click()
  With cmdlg
    .Filter = "Word- und PDF-Dateien|*.doc;*.pdf|Alle Dateien|*.*"
    .Flags = cdlOFNFileMustExist Or cdlOFNExplorer
    .ShowOpen
    If .FileName <> vbNullString Then
      printFile .FileName ' der eigentliche Druckauftrag
    End If
  End With
End Sub

Private Sub Combo1_Click()
  Dim prn As Printer
  
  If Combo1.Text <> noPrinter Then
    For Each prn In Printers
      If prn.DeviceName = Combo1.Text Then
        Set Printer = prn
        Exit For
      End If
    Next prn
    Label1(3).Caption = Printer.DeviceName
  End If
End Sub

Private Sub Form_Load()
  Dim x As Long, y As Long
  Dim PrinterName As String
  
  ' Druckerdaten einlesen:
  y = -1
  For x = 0 To Printers.Count - 1
    PrinterName = Printers(x).DeviceName
    Combo1.AddItem PrinterName
    If PrinterName = Printer.DeviceName Then y = x
  Next x
  If y = -1 Then
    Combo1.AddItem noPrinter
    Combo1.ListIndex = Combo1.ListCount - 1
    cmdPrint.Enabled = False
  Else
    Combo1.ListIndex = y
  End If
  Label1(2).Caption = getDefaultPrinter
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Set frmMain = Nothing
End Sub

' Druckt eine Datei mit der im System verknpften Anwendung,
' wird keine Anwendung gefunden (Ergebnis = 31), so ffnet sich der
' Verknpfungsdialog des Betriebssystems ber den Shell-Ausdruck
Private Function printFile(ByVal FileName As String) As Boolean
  Dim path As String
  Dim stdPrinter As String
  
  stdPrinter = getDefaultPrinter        ' Standard-Drucker sichern
  setDefaultPrinter Printer.DeviceName  ' VB-Printer zum Standard erklren
  DoEvents                              ' dem BS etwas Zeit geben ;-)
  path = Left$(FileName, InStrRev(FileName, "\"))
  ' API-Druckbefehl absetzen:
  If ShellExecute(hWnd, "print", FileName, vbNullString, path, vbHide) = 31 Then
    Shell ("rundll32.exe SHELL32,OpenAs_RunDLL " & FileName)
  Else
    printFile = True
  End If
  setDefaultPrinter stdPrinter          ' Standard-Drucker wiederherstellen
End Function

Private Sub vbzentrum_Click()
  Me.MousePointer = vbHourglass
  ShellExecute Me.hWnd, "Open", "http://www.vb-zentrum.de", "", "", vbNormalFocus
  Me.MousePointer = vbDefault
End Sub

